var EXPORTED_SYMBOLS = ['util'];

const util = {

  trim: function(txt) {
    txt = txt.replace(/^\s+/, '');
    for (var idx = txt.length - 1; idx > 0; idx--) {
        if (/\S/.test(txt.charAt(idx))) {
            txt = txt.substring(0, idx + 1);
            break;
        }
    }
    return txt;
  },

  stringToUri: function(spec) {
    try {
      return Components
        .classes['@mozilla.org/network/io-service;1']
        .getService(Components.interfaces.nsIIOService)
        .newURI(spec, null, null);
    } catch (ex) {
      return null;
    }
  },

  getText: function(msg, args) {
    return Components
      .classes['@mozilla.org/intl/stringbundle;1']
      .getService(Components.interfaces.nsIStringBundleService)
      .createBundle('chrome://migre-me-hultmann/locale/general.properties')
      .formatStringFromName(msg, args, args.length);
  },

  log: function(msg) {
    var now = new Date();
    var p = '[migre.me' + ' ' + now.toLocaleTimeString() + '] ';
    dump('\n------------------------------------------------------------------\n' + p + msg);
    Components
      .classes['@mozilla.org/consoleservice;1']
      .getService(Components.interfaces.nsIConsoleService)
      .logStringMessage(p + msg);
  },

  findCurrentUrlPos: function(txt, idx) {
    var bounds = [' ', '\n', '\t', '(', ')', '"', "'", "<", ">"];
    var mySort = function(a, b) {
      return a - b;
    };

    var stopChars = bounds.map(function(myChar) {
      var idx2 = txt.indexOf(myChar, idx);
      return idx2 === -1 ? Infinity : idx2;
    });


    stopChars.sort(mySort);
    var endNearest = stopChars[0];
    var lastChar = (endNearest === Infinity ? txt.length : endNearest) - 1;


    var startChars = bounds.map(function(myChar) {
      return txt.lastIndexOf(myChar, lastChar);
    });

    startChars.sort(mySort);
    var startNearest = startChars[startChars.length - 1];

    var firstChar = startNearest == -1 ? 0 : startNearest + 1;
    return [firstChar, lastChar - firstChar + 1];
  }

};
